/*
CGI.h
*/

#ifndef __CGI_H
#define __CGI_H

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "Config.h"
#include "Utils.h"
#include "cgi-llist.h"
#include "cgi-lib.h"

class CGI
  {
  private:
    llist entries, cookies;
    char *THEPATH_INFO, *stcmd, *stsubcmd, *stlang, *user, *connid, 
         *validator, *pageid, *lastcmd, 
         *parm1, *parm2, *parm3, *parm4;
    int CodeUpload, Num_Cookies;
    void Parse_PATH_INFO (char *apath);
  public:
    CGI (char *UPLOADBASEDIRATTACHS);
    virtual ~CGI ();
    int getCodeUpload (void);
    char *GetEntry (char *name);
    char *GetMultipleEntries (char *name, char *SEP);    
    char *GetEntryDef (char *name, char *def);
    bool GetEntryBool (char *name);
    char *get_REMOTE_ADDR (char *def);
    char *get_PATHINFO (void);    
    char *get_COOKIE (void);
    void PrintAllEntries();    
    int getNumCookies (void);
    char *get_Cookie (char *id);
    char *getCmd ();
    char *getSubCmd ();
    char *getLang ();
    char *getUser ();
    char *getConnid ();
    char *getValidator();
    char *getPageId();
    char *getLastCmd();
    char *getParm1 ();
    char *getParm2 ();
    char *getParm3 ();
    char *getParm4 ();    
  };

#endif
